/*8052 ASSEMBLER HEADER FILE*/

#include <stdlib.h>
#include <errno.h>
#include <stdio.h>
#include <asm/io.h>
#include <unistd.h>

#define FIELDLENGTH		20
#define LABELLENGTH		20
#define LABELTABLENGTH	499
#define OK			0
#define ERROR		-1
#define DATA		0
#define ADDR		1
#define REGISTER	2
#define IMDATA		3

#define AREG			32
#define BREG			33
#define CARRY			34
#define ABREG			35
#define DPTR			16
#define QDPTR			17
#define QAPLDPTR		18
#define QAPLPC			19
#define QR0				6
#define QR1				7
#define RELI			8
#define LABEL			64
#define FIELDL			20
#define MAXLAB			10000
#define EQUTABLENGTH	256
#define MAXFIELDS		16


char rv,lierfl,intefl,hexfifl,equfl,eqerfl;
char field,fields,ab[20];
char td[20],te[20],tf[20],tg[20],th[20],ti[20],tj[20];
char oper[MAXFIELDS][FIELDL];
FILE *f1,*f2,*f3,*f4,*f5;
unsigned int t[MAXFIELDS],r[MAXFIELDS],e[MAXFIELDS];
unsigned int o[FIELDL];
/*
for db FIELDL bytes is the max. 
for ds FIELDL bytes is the max.
*/
unsigned int pc,error,errors,pass,opcs,pco,pci,ils,extfl,listfl;
unsigned int strfl,licnt,basfifl,lle,remfl,labfl,symfl;
unsigned int orgval,orgfl,forgfl,basli,codbyt,uppfl;
char labelt[MAXLAB][FIELDL],labelf[MAXLAB];
unsigned int labelv[MAXLAB];
char irectyp,irecofl;
unsigned int irecdat[17],ireclen,irecadd;
unsigned int hrecdat[17],hreclen,hrecadd;
char hrecofl;

struct equtab
	{
	char *text;
	char *replac;
	struct equtab *nxtentr;/*next entry to table*/
	};
static struct equtab *pnttab[EQUTABLENGTH];/*pointer table*/

